#include "intrinsic.h"

bool
INTRINSIC_LIST::set(INTRINSIC_NAMES in)
{
    return setTimed(in , -1);
}

bool
INTRINSIC_LIST::setTimed(INTRINSIC_NAMES in, int timer)
{
    bool	result = get(in);
    int		i;

    for (i = myIntList.entries(); i --> 0;)
    {
	if (myIntList(i).in == in)
	    break;
    }
    if (i < 0)
    {
	INTSTRUCT is;
	is.in = in;
	is.timer = 0;
	i = myIntList.append(is);
    }
    if (timer < 0)
    {
	myIntList(i).timer = timer;
    }
    else if (myIntList(i).timer >= 0)
    {
	myIntList(i).timer += timer;
    }
    return result;
}

bool
INTRINSIC_LIST::clear(INTRINSIC_NAMES in)
{
    bool	result = get(in);

    for (int i = myIntList.entries(); i --> 0;)
    {
	if (myIntList(i).in == in)
	{
	    myIntList.removeAt(i);
	}
    }
    return result;
}

void
INTRINSIC_LIST::clearAll()
{
    myIntList.clear();
}

bool
INTRINSIC_LIST::get(INTRINSIC_NAMES in) const
{
    for (int i = 0; i < myIntList.entries(); i++)
    {
	if (myIntList(i).in == in)
	    return true;
    }
    return false;
}

void
INTRINSIC_LIST::heartbeat()
{
    for (int i = myIntList.entries(); i --> 0;)
    {
	if (myIntList(i).timer < 0)
	    continue;
	myIntList(i).timer--;
	if (myIntList(i).timer < 0)
	{
	    myIntList.removeAt(i);
	}
    }
}

