#pragma once

#include "glbdef.h"
#include "pos.h"
#include "ptrlist.h"
#include "buf.h"

class ITEM
{
public:
    ITEM(ITEM_NAMES defn);
    ~ITEM();

    const ITEM_DEF &defn() const { return glb_itemdefs[myDefinition]; }
    ITEM_NAMES		getDefinition() const { return myDefinition; }
    void		setDefinition(ITEM_NAMES item) { myDefinition = item; }

    TILE_NAMES		tile() const;
    TILE_NAMES		tile(int &toffx, int &toffy) const;

    POS			pos() const { return myPos; }
    void		moveTo(POS newpos);

    MOB_NAMES		getBaseMob() const { return myBaseMob; }
    void		setBaseMob(MOB_NAMES mob) { myBaseMob = mob; }
    DIR			getFacing() const { return myFacing; }
    void		setFacing(DIR dir) { myFacing = dir; }

    // Return true if still alive
    bool		heartbeat(int phase);
    // Return true if still alive
    bool		damage(int damage);
    bool		heal(int heal);

protected:
    ITEM_NAMES		myDefinition;
    POS			myPos;
    MOB_NAMES		myBaseMob;
    DIR			myFacing;
    int			myHP;
};


typedef PTRLIST<ITEM *> ITEMLIST;
